<?php
/*
Plugin Name: Buy Me a Beer
Plugin URI: http://www.blogclout.com/blog/goodies/buy-me-a-beer-paypal-donation-plugin/
Description: Allow your blog visitors to buy you a beer by sending you money through PayPal. A special <a href="http://www.blogblout.com/blog" target="blogclout">BlogClout</a> plugin 
Author: Sherief Mursyidi
Version: 1.4
Author URI: http://www.blogclout.com/blog/about-sherief-mursyidi/
-----
- 17.05.2007	Add option to show Buy Me a Beer per post or page.

- 18.05.2007	Add function to show Buy Me Beer in sidebar and content.

- 22.05.2007	Fixed comment form bug.
				Fixed single post bug.
				Add Amount paypal details.
				Add Name on content details.
				Change the item name algorithm.

- 26.07.2007	Add currency.
-----

*/

load_plugin_textdomain('buymebeer');

class buymebeer {
	function do_widget() {
		if (function_exists('register_sidebar_widget')) {
			register_sidebar_widget('Buy Me a Beer', array('buymebeer', 'display_widget'));
		}
	}
	
	function display_widget($args) {
		echo buymebeer::display($args);
	}
	
	function display($args = null) {
		if(!empty($args)) extract($args);
		$options = (array) get_settings('buymebeer-params');
		if ( !isset($args['before_widget']) ) {
			$args['before_widget'] = '';
		}
		if ( !isset($args['after_widget']) ) {
			$args['after_widget'] = '';
		}
		if ( !isset($args['before_title']) ) {
			$args['before_title'] = '<h2><strong>';
		}
		if ( !isset($args['after_title']) ) {
			$args['after_title'] = '</strong></h2>';
		}
		if ( !isset($args['title']) ) {
			if ( isset($options['title']) ) {
				$args['title'] = $options['title'];
			} else {
				$args['title'] = __('Buy Me a Beer');
			}
		}
		echo $args['before_widget'] . $args['before_title'] . $args['title'] . $args['after_title'];
		$paypal_link = "https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&amp;business=".$options['business']."&amp;currency_code=".$options['currency']."&amp;amount=".$options['amount']."&amp;return=".$options['thankspage']."&amp;item_name=".str_replace(" ","+",$args['title']);
		?>
		<form name="buymebeer" action="https://www.paypal.com/cgi-bin/webscr" target="paypal" method="post">
		<input type="hidden" name="cmd" value="_xclick" />
		<input type="hidden" name="business" value="<?php echo $options['business']?>" />
		<input type="hidden" name="return" value="<?php echo $options['thankspage']?>" />
		<input type="hidden" name="item_name" value="<?php echo $args['title']?>" />
		<input type="hidden" name="currency_code" value="<?php echo $args['currency']?>" />
		<input type="hidden" name="amount" value="<?php echo $options['amount']?>" />
		<input type="image" src="<?php echo str_replace(ABSPATH, get_settings('siteurl').'/', dirname(__FILE__)) . "/".$options['image'].'.gif';?>" align="left" alt="<?php echo $options['alttext'];?>" title="<?php echo $options['alttext'];?>" />		
		<?php echo "<a href=\"$paypal_link\" target=\"paypal\">".$options['text']."</a>";?>
		</form>
		<div style="clear: both;"></div><br />
		<?php echo $args['after_widget']; ?>
		<?php
	}
	
	function add_buymebeer_to_content($content) {
		global $post;
		$show_button = false;
		$buymebeerpost = "no";
		
		$buymebeerpost = get_post_meta($post->ID, 'buymebeer-post', $single = true);
		$options = (array) get_settings('buymebeer-params');
		
		if($options['autocontent'] == "1" && $buymebeerpost <> "no") $show_button = true;
		if($buymebeerpost == "yes") $show_button = true;
		
		if($show_button) {
			if($options['contentname'] == '' || empty($options['contentname'])) $options['contentname'] = "Buy Me a Beer";
		
			$paypal_contentlink = "https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&amp;business=".$options['business']."&amp;currency_code=".$options['currency']."&amp;amount=".$options['amount']."&amp;return=".$options['thankspage']."&amp;item_name=".str_replace(" ","+",$options['contentname'])."+for+".str_replace(" ","+",$post->post_title);
			
			$additional_content  = "<form action=\"https://www.paypal.com/cgi-bin/webscr\" target=\"paypal\" method=\"post\">";
			$additional_content .= "<input type=\"hidden\" name=\"cmd\" value=\"_xclick\" />";
			$additional_content .= "<input type=\"hidden\" name=\"business\" value=\"".$options['business']."\" />";
			$additional_content .= "<input type=\"hidden\" name=\"return\" value=\"".$options['thankspage']."\" />";
			$additional_content .= "<input type=\"hidden\" name=\"item_name\" value=\"".$options['contentname']." for ".$post->post_title."\" />";
			$additional_content .= "<input type=\"hidden\" name=\"currency_code\" value=\"".$options['currency']."\" />";
			$additional_content .= "<input type=\"hidden\" name=\"amount\" value=\"".$options['amount']."\" />";
			$additional_content .= "<input type=\"image\" src=\"".str_replace(ABSPATH, get_settings('siteurl').'/', dirname(__FILE__)) . "/icon_".$options['icon'].".gif\" align=\"left\" alt=\"".$options['contentalttext']."\" title=\"".$options['contentalttext']."\" hspace=\"3\" />";
			$additional_content .= "</form>";
			$additional_content .= "<a href=\"$paypal_contentlink\" target=\"paypal\">".$options['contenttext']."</a>";
			$content .= '<p class="buymebeer">'.$additional_content.'</p>';
		}
		return $content;
	}
	
	function content_display() {
		global $post;
		$options = (array) get_settings('buymebeer-params');
		if($options['contentname'] == '' || empty($options['contentname'])) $options['contentname'] = "Buy Me a Beer";
		
		$paypal_contentlink = "https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&amp;business=".$options['business']."&amp;currency_code=".$options['currency']."&amp;amount=".$options['amount']."&amp;return=".$options['thankspage']."&amp;item_name=".str_replace(" ","+",$options['contentname'])."+for+".str_replace(" ","+",$post->post_title);
		$additional_content  = "<form action=\"https://www.paypal.com/cgi-bin/webscr\" target=\"paypal\" method=\"post\">";
		$additional_content .= "<input type=\"hidden\" name=\"cmd\" value=\"_xclick\" />";
		$additional_content .= "<input type=\"hidden\" name=\"business\" value=\"".$options['business']."\" />";
		$additional_content .= "<input type=\"hidden\" name=\"return\" value=\"".$options['thankspage']."\" />";
		$additional_content .= "<input type=\"hidden\" name=\"item_name\" value=\"".$options['contentname']." ".$post->post_title."\" />";
		$additional_content .= "<input type=\"hidden\" name=\"currency_code\" value=\"".$options['currency']."\" />";
		$additional_content .= "<input type=\"hidden\" name=\"amount\" value=\"".$options['amount']."\" />";
		$additional_content .= "<input type=\"image\" src=\"".str_replace(ABSPATH, get_settings('siteurl').'/', dirname(__FILE__)) . "/icon_".$options['icon'].".gif\" align=\"left\" alt=\"".$options['contentalttext']."\" title=\"".$options['contentalttext']."\" hspace=\"3\" />";
		$additional_content .= "</form>";
		$additional_content .= "<a href=\"$paypal_contentlink\" target=\"paypal\">".$options['contenttext']."</a>";
		$buymebeer_content = "<p class=\"buymebeer\">".$additional_content."</p>";
		
		echo $buymebeer_content;
	}
}

add_action('the_content', array('buymebeer','add_buymebeer_to_content'));
add_action('plugins_loaded', array('buymebeer', 'do_widget'));

function buymebeer_sidebar() {
	echo buymebeer::display();
}

function buymebeer_content() {
	echo buymebeer::content_display();
}

if ( strpos($_SERVER['REQUEST_URI'], 'wp-admin') !== false ) {
	include_once dirname(__FILE__) . '/buy-me-beer-admin.php';
}
?>